/**
 *数据库操作辅助类,定义对象、数据操作方法都在这里定义
 */
var dbname = 'wmrwebsql'; /*数据库名*/
var dbversion = '1.0'; /*数据库版本*/
var dbdesc = ''; /*数据库描述*/
var dbsize = 2 * 1024 * 1024; /*数据库大小*/
var dataBase = null; /*暂存数据库对象*/
/*数据库中的表单名*/
var diarytable = "diarytable";

/**
 * 打开数据库
 * @returns  dataBase:打开成功   null:打开失败
 */
function opendb() {
	/*数据库有就打开 没有就创建*/
	dataBase = window.openDatabase(dbname, dbversion, dbdesc, dbsize, function() {});
	if(dataBase) {
		console.log("数据库创建/打开成功!");
	} else {
		console.log("数据库创建/打开失败!");
	}
	return dataBase;
}
/**
 * 新建数据库里面的表单
 * @param tableName:表单名
 */
function createtable(tableName) {
	//  chinaAreaOpenDB();
	var creatTableSQL = 'CREATE TABLE IF  NOT EXISTS ' + tableName + ' (rowid INTEGER PRIMARY KEY AUTOINCREMENT, title text,time text,content text)';
	dataBase.transaction(function(ctx, result) {
		ctx.executeSql(creatTableSQL, [], function(ctx, result) {
			console.log("表创建成功 " + tableName);
		}, function(tx, error) {
			console.log('创建表失败:' + tableName + error.message);
		});
	});
}

function create_product_list() {
	//  chinaAreaOpenDB();
	var creatTableSQL = 'CREATE TABLE IF  NOT EXISTS product_list (rowid INTEGER PRIMARY KEY AUTOINCREMENT, productmodel text,productname text)';
	dataBase.transaction(function(ctx, result) {
		ctx.executeSql(creatTableSQL, [], function(ctx, result) {
			console.log("产品列表创建成功 ");
		}, function(tx, error) {
			console.log('产品列表创建失败:' + error.message);
		});
	});
}

function create_product_field() {
	//  chinaAreaOpenDB();
	var creatTableSQL = 'CREATE TABLE IF  NOT EXISTS product_field (rowid INTEGER PRIMARY KEY AUTOINCREMENT, fieldname text)';
	dataBase.transaction(function(ctx, result) {
		ctx.executeSql(creatTableSQL, [], function(ctx, result) {
			console.log("产品字段表创建成功 ");
		}, function(tx, error) {
			console.log('产品字段表创建失败:' + error.message);
		});
	});
}

function create_product_detail() {
	//  chinaAreaOpenDB();
	var creatTableSQL = 'CREATE TABLE IF  NOT EXISTS product_detail (rowid INTEGER PRIMARY KEY AUTOINCREMENT, productfield text,productvalue text,productid INTEGER)';
	dataBase.transaction(function(ctx, result) {
		ctx.executeSql(creatTableSQL, [], function(ctx, result) {
			console.log("产品详情表创建成功 ");
		}, function(tx, error) {
			console.log('产品详情表创建失败:' + error.message);
		});
	});
}

function create_hs() {
	//  chinaAreaOpenDB();
	var creatTableSQL = 'CREATE TABLE IF  NOT EXISTS HS (rowid INTEGER PRIMARY KEY AUTOINCREMENT, bianma text,mingcheng text,daima text,putong text,youhui text,beizhu text,chukou text,xiaofei text,zengzhi text,diyi text,dier text,tuishui text)';
	dataBase.transaction(function(ctx, result) {
		ctx.executeSql(creatTableSQL, [], function(ctx, result) {
			console.log("HS表创建成功 ");
		}, function(tx, error) {
			console.log('HS表创建失败:' + error.message);
		});
	});
}

function create_port() {
	//  chinaAreaOpenDB();
	var creatTableSQL = 'CREATE TABLE IF  NOT EXISTS port (rowid INTEGER PRIMARY KEY AUTOINCREMENT, guojiazhongwen text,quyu text,gangkouzhongwen text,guojiayingwen text,gangkoudaima text,gangkouyingwen text,neilugang text,changyong text,piangang text,guojiadaihao text,gangkoudaihao text)';
	dataBase.transaction(function(ctx, result) {
		ctx.executeSql(creatTableSQL, [], function(ctx, result) {
			console.log("港口表创建成功 ");
		}, function(tx, error) {
			console.log('港口表创建失败:' + error.message);
		});
	});
}
/**
 * 往日记表里面插入数据
 */
function inserttodiary(tableName, title, time, content) {
	var insterTableSQL = 'INSERT INTO ' + tableName + ' (title,time,content) VALUES (?,?,?)';
	dataBase.transaction(function(ctx) {
		ctx.executeSql(insterTableSQL, [title, time, content], function(ctx, result) {
				console.log("插入" + tableName + title + "成功");
				localStorage.setItem("newdiary", "success");
			},
			function(tx, error) {
				console.log('插入失败: ' + error.message);
				localStorage.setItem("newdiary", "fail");
			});
	});
}

/**
 * 删除表
 * @param tableName:表单名
 */
function droptable(tableName) {
	var droptableSQL = 'drop table ' + tableName;
	dataBase.transaction(function(ctx) {
		ctx.executeSql(droptableSQL, [], function(ctx, result) {
				console.log("删除" + tableName + "成功");
			},
			function(tx, error) {
				console.log("删除" + tableName + "成功");
			});
	});
}
/**
 * 获取日记表里面的所有数据
 * @param tableName:表单名
 * 返回数据集合
 */
function listdata(tableName) {
	var selectALLSQL = 'SELECT * FROM ' + tableName + ' order by rowid desc';
	dataBase.transaction(function(ctx) {
		ctx.executeSql(selectALLSQL, [], function(ctx, result) {
				var len = result.rows.length;
				localStorage.setItem("len", len);
				if(len > 0) {
					for(var i = 0; i < len; i++) {
						localStorage.setItem("rowid" + i, result.rows.item(i).rowid);
						localStorage.setItem("title" + i, result.rows.item(i).title);
						localStorage.setItem("time" + i, result.rows.item(i).time);
						localStorage.setItem("content" + i, result.rows.item(i).content.substr(0, 20));
					}
				}
			},
			function(tx, error) {
				alert('查询失败: ' + error.message);
			});
	});
}
/**
 * 根据标题查找日记表
 * @param tableName:表单名
 */
function searchdata(tableName, search) {
	var selectSQL = 'SELECT * FROM ' + tableName + ' WHERE title like "%' + search + '%" order by rowid desc';
	console.log(selectSQL);
	dataBase.transaction(function(ctx) {
		ctx.executeSql(selectSQL, [], function(ctx, result) {
				var len = result.rows.length;
				localStorage.setItem("len", len);
				if(len > 0) {
					for(var i = 0; i < len; i++) {
						localStorage.setItem("rowid" + i, result.rows.item(i).rowid);
						localStorage.setItem("title" + i, result.rows.item(i).title);
						localStorage.setItem("time" + i, result.rows.item(i).time);
						localStorage.setItem("content" + i, result.rows.item(i).content.substr(0, 20));
					}
				}
			},
			function(tx, error) {
				alert('查询失败: ' + error.message);
			});
	});
}

/**
 * 根据HS编码或者名称查找HS表
 */
function searchhs(search) {
	var selectSQL = 'SELECT * FROM HS WHERE bianma like "%' + search + '%" or mingcheng like "%' + search + '%" order by rowid desc limit 50';
	dataBase.transaction(function(ctx) {
		ctx.executeSql(selectSQL, [], function(ctx, result) {
				var len = result.rows.length;
				localStorage.setItem("hs_len", len);
				if(len > 0) {
					for(var i = 0; i < len; i++) {
						localStorage.setItem("hs_rowid" + i, result.rows.item(i).rowid);
						localStorage.setItem("hs_bianma" + i, result.rows.item(i).bianma);
						localStorage.setItem("hs_mingcheng" + i, result.rows.item(i).mingcheng);
						localStorage.setItem("hs_daima" + i, result.rows.item(i).daima);
						localStorage.setItem("hs_putong" + i, result.rows.item(i).putong);
						localStorage.setItem("hs_youhui" + i, result.rows.item(i).youhui);
						localStorage.setItem("hs_beizhu" + i, result.rows.item(i).beizhu);
						localStorage.setItem("hs_chukou" + i, result.rows.item(i).chukou);
						localStorage.setItem("hs_xiaofei" + i, result.rows.item(i).xiaofei);
						localStorage.setItem("hs_zengzhi" + i, result.rows.item(i).zengzhi);
						localStorage.setItem("hs_diyi" + i, result.rows.item(i).diyi);
						localStorage.setItem("hs_dier" + i, result.rows.item(i).dier);
						localStorage.setItem("hs_tuishui" + i, result.rows.item(i).tuishui);
					}
				}
			},
			function(tx, error) {
				alert('查询失败: ' + error.message);
			});
	});
}

/**
 * 根据港口编码或者名称查找港口表
 */
function searchport(search) {
	var selectSQL = 'SELECT * FROM port WHERE guojiazhongwen like "%' + search + '%" or gangkouzhongwen like "%' + search + '%" or guojiayingwen like "%' + search + '%" or gangkoudaima like "%' + search + '" or gangkouyingwen like "%' + search + '%" or gangkoudaihao = "' + search + '" order by rowid desc limit 50';
	dataBase.transaction(function(ctx) {
		ctx.executeSql(selectSQL, [], function(ctx, result) {
				var len = result.rows.length;
				localStorage.setItem("port_len", len);
				if(len > 0) {
					for(var i = 0; i < len; i++) {
						localStorage.setItem("port_rowid" + i, result.rows.item(i).rowid);
						localStorage.setItem("port_guojiazhongwen" + i, result.rows.item(i).guojiazhongwen);
						localStorage.setItem("port_quyu" + i, result.rows.item(i).quyu);
						localStorage.setItem("port_gangkouzhongwen" + i, result.rows.item(i).gangkouzhongwen);
						localStorage.setItem("port_guojiayingwen" + i, result.rows.item(i).guojiayingwen);
						localStorage.setItem("port_gangkoudaima" + i, result.rows.item(i).gangkoudaima);
						localStorage.setItem("port_gangkouyingwen" + i, result.rows.item(i).gangkouyingwen);
						localStorage.setItem("port_neilugang" + i, result.rows.item(i).neilugang);
						localStorage.setItem("port_changyong" + i, result.rows.item(i).changyong);
						localStorage.setItem("port_piangang" + i, result.rows.item(i).piangang);
						localStorage.setItem("port_guojiadaihao" + i, result.rows.item(i).guojiadaihao);
						localStorage.setItem("port_gangkoudaihao" + i, result.rows.item(i).gangkoudaihao);
					}
				}
			},
			function(tx, error) {
				alert('查询失败: ' + error.message);
			});
	});
}
/**
 * 按ID获取一条日记
 * @param tableName:表单名
 * @param rowid:rowid
 */
function viewbyid(tableName, rowid) {
	var selectSQL = 'SELECT * FROM ' + tableName + ' WHERE rowid = ?'
	dataBase.transaction(function(ctx) {
		ctx.executeSql(selectSQL, [rowid], function(ctx, result) {
				var len = result.rows.length;
				localStorage.setItem("viewlen", len);
				if(len > 0) {
					localStorage.setItem("viewid", result.rows.item(0).rowid);
					localStorage.setItem("viewtitle", result.rows.item(0).title);
					localStorage.setItem("viewtime", result.rows.item(0).time);
					localStorage.setItem("viewcontent", result.rows.item(0).content);
				}
			},
			function(tx, error) {
				alert('查询失败: ' + error.message);
			});
	});
}
/**
 * 删除表单里的全部数据
 * @param tableName:表单名
 */
function websqlDeleteAllDataFromTable(tableName) {
	var deleteTableSQL = 'DELETE FROM ' + tableName;
	dataBase.transaction(function(ctx, result) {
		ctx.executeSql(deleteTableSQL, [], function(ctx, result) {
			//alert("删除全部数据成功 " + tableName);
		}, function(tx, error) {
			//alert('删除全部数据失败:' + tableName + error.message);
		});
	});
}
/**
 * 根据id删除数据
 * @param tableName:表单名
 */
function websqlDeleteADataFromTable(tableName, rowid) {
	var deleteDataSQL = 'DELETE FROM ' + tableName + ' WHERE rowid = ?';
	console.log(deleteDataSQL);
	//localStorage.removeItem(tableName);    移除某条记录
	dataBase.transaction(function(ctx, result) {
		ctx.executeSql(deleteDataSQL, [rowid], function(ctx, result) {
			alert("删除成功 ");
		}, function(tx, error) {
			alert('删除失败:' + error.message);
		});
	});
}
/*批量插入数据
 * 
 */
function bulkinsert() {
	websqlDeleteAllDataFromTable("HS");
	websqlDeleteAllDataFromTable("port");
	dataBase.transaction(function(ctx) {
		for(var i = 0; i < portinsertsql.length; i++) {
			ctx.executeSql(portinsertsql[i], [], function(ctx, result) {
					//console.log("插入成功");
				},
				function(tx, error) {
					//console.log('插入失败: '  + error.message);
				});
		}
	});
	dataBase.transaction(function(ctx) {
		for(var i = 0; i < 5000; i++) {
			//strSql='INSERT INTO product_field (fieldname) VALUES ("aaaaaaa")';
			ctx.executeSql(hsinsertsql[i], [], function(ctx, result) {
					//console.log("插入成功");
				},
				function(tx, error) {
					//console.log('插入失败: '  + error.message);
				});
		}
	});
	dataBase.transaction(function(ctx) {
		for(var i = 5000; i < hsinsertsql.length - 1; i++) {
			ctx.executeSql(hsinsertsql[i], [], function(ctx, result) {
					//console.log("插入"+i+"成功");   //这里放i不会起作用
				},
				function(tx, error) {
					console.log('插入失败: ' + error.message);
				});
			if(i == hsinsertsql.length - 1) {
				localStorage.setItem("installed", "ok");
			}
		}
	});
	dataBase.transaction(function(ctx) {
		ctx.executeSql(hsinsertsql[hsinsertsql.length - 1], [], function(ctx, result) {
				localStorage.setItem("installed", "ok");
			},
			function(tx, error) {
				console.log('插入失败: ' + error.message);
			});
	});
}